<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2011 Helmut Hackbarth <info@t3solution.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Plugin 'JSliderNews' for the 't3s_jslidernews' extension.
 *
 * @author	Helmut Hackbarth <info@t3solution.de>
 * @package	TYPO3
 * @subpackage	tx_t3sjslidernews
 */
class tx_t3sjslidernews_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_t3sjslidernews_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_t3sjslidernews_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 't3s_jslidernews';	// The extension key.
	var $pi_checkCHash = true;

	var $imageWidth = null;
	var $imageHeight = null;
	var $thumbnailWidth = null;
	var $thumbnailHeight = null;
	var $sliderWidth = null;
	var $sliderHeight = null;
	var $extPath = null;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	public function main($content, $conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();

    $this->extPath = t3lib_extMgm::siteRelPath($this->extKey);
 
    $this->init();

    switch ($this->conf['contentStyle']) {
      case 'tt_news':
        $sliderNewsRecords = $this->getSliderNewsRecords();
        $content = $this->getNews($sliderNewsRecords);
      break;
      case 'tt_content':
        $sliderContentRecords = $this->getSliderContentRecords();
        $content = $this->getContent($sliderContentRecords);
      break;
    }

    $this->addHeaderParts();
	
		return $this->pi_wrapInBaseClass($content);
	}

 
	protected function init(){
    $this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
 		foreach ($piFlexForm['data'] as $sheet => $data) {
			foreach ($data as $lang => $value) {
				foreach ($value as $key => $val) {
						$this->conf[$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
        }
      }
    }
  }	


	protected function getSliderNewsRecords() {
    $select = 'tt_news.uid,tt_news.pid,tt_news.title,tt_news.image,tt_news.short,tt_news.author,tt_news.bodytext,
    tt_news.datetime,tt_news.imagetitletext,tt_news.imagealttext,tt_news.l18n_parent';
    $whereClause = 'AND tt_news_cat_mm.uid_foreign = '.$this->conf['sliderCat'];  
    $whereClause .= ' AND tt_news.sys_language_uid = ' . $GLOBALS['TSFE']->sys_language_content;  
    $whereClause .= $this->cObj->enableFields('tt_news_cat');
    $whereClause .= $this->cObj->enableFields('tt_news');
    $sliderRecords = array();
    if ($this->conf['newsLimit']) {
      $res = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query($select, 'tt_news', 'tt_news_cat_mm', 'tt_news_cat', $whereClause,'','',$this->conf['newsLimit']);
    } else {
      $res = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query($select, 'tt_news', 'tt_news_cat_mm', 'tt_news_cat', $whereClause);
    }
    while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
          $sliderRecords[$row['uid']] = $row;
      if ($GLOBALS['TSFE']->sys_language_content) {
        $res2 = $GLOBALS['TYPO3_DB']->exec_SELECTquery( 'image', 'tt_news', ' uid=' . $sliderRecords[$row['uid']]['l18n_parent'] );
        $row2 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $res2 );
        $sliderRecords[]['image'] = $row2['image'];

        $GLOBALS['TYPO3_DB']->sql_free_result($res2); 
      }   
    }
    $GLOBALS['TYPO3_DB']->sql_free_result($res); 

    return $sliderRecords; 
  }


	protected function getSliderContentRecords() {
    $contentElements = t3lib_div::trimExplode(',', $this->conf['contentElement']);	
    $sliderRecords = array();
 		foreach ($contentElements as $contentElement) {
      $select = 'uid,pid,header,bodytext,image,subheader,imagecaption,date';
      if ($GLOBALS['TSFE']->sys_language_content) {
        $whereClause = 'l18n_parent='.$contentElement;  
      } else {
        $whereClause = 'uid='.$contentElement;  
      }
      $whereClause .= ' AND CType=\'textpic\'';
      $whereClause .= ' AND sys_language_uid = ' . $GLOBALS['TSFE']->sys_language_content;  
      $whereClause .= $this->cObj->enableFields('tt_content');
      $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select, 'tt_content', $whereClause);
      while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
            $sliderRecords[] = $row;
      }
    }
    $GLOBALS['TYPO3_DB']->sql_free_result($res); 

    return $sliderRecords; 
  }


 	protected function getNews($sliderRecords) {
    if (!$this->conf['templateFile']) {
      $this->conf['templateFile'] = $this->extPath.'slidernews_template.html';
    }
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');
    $uploadDir = 'uploads/pics/';

    if ($this->conf['sliderWidth']) {
      $this->sliderWidth = $this->conf['sliderWidth'];
      $this->sliderHeight = '300';
    } else {
      $firstImageResord = reset($sliderRecords);
      $firstImage = t3lib_div::trimExplode(',', $firstImageResord['image']);
      $imageSize    = getimagesize(PATH_site . $uploadDir . $firstImage['0']);
      $this->sliderWidth = $imageSize['0'];
      $this->sliderHeight  =  '300';
    }
    if ($this->conf['sliderHeight']) {
      if ($this->conf['sliderStyle'] == '1' || $this->conf['sliderStyle'] == '4' || $this->conf['sliderStyle'] == '6') { 
        $this->sliderHeight = $this->conf['sliderHeight'];
      }
    }
                     
    $this->imageWidth = $this->sliderWidth;
    $this->imageHeight = $this->sliderHeight;

    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '5') {
      $this->imageWidth = $this->sliderWidth - '295';
    } 
    if ($this->conf['sliderStyle'] == '3') {
      $this->imageWidth = $this->sliderWidth - '293';
    }

    $marks['###SLIDERWIDTH###'] = $this->sliderWidth;
    $marks['###IMAGEWIDTH###'] = $this->imageWidth;
    $marks['###IMAGEHEIGHT###'] = $this->imageHeight;
    
    $thumbnailWidth  = $this->imageWidth / '12';
    $this->thumbnailWidth  = t3lib_div::intval_positive($thumbnailWidth);
    $thumbnailHeight  = $this->imageHeight / '12';
    $this->thumbnailHeight  = t3lib_div::intval_positive($thumbnailHeight);
    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '3' || $this->conf['sliderStyle'] == '5') {
      $this->thumbnailWidth  = '60';
      $this->thumbnailHeight  = '60';
    }

 		foreach ($sliderRecords as $key => $record) {
      $linkConf = array(
        'parameter'         => $this->conf['ttnewsSinglePid'],
        'additionalParams'  => '&tx_ttnews[tt_news]= '.$record['uid'],
        'useCacheHash'      => '1',
        'ATagParams'        => 'class="readmore"',
        'target'            => '_parent'
      );
      $imageRecord = t3lib_div::trimExplode(',', $record['image']);

      $imageConf['file'] = $uploadDir . $imageRecord['0'];
      $imageConf['file.']['width'] = intval($this->imageWidth).'c';
      $imageConf['file.']['height'] = intval($this->imageHeight);
      $imageConf['stdWrap.']['addParams.']['title'] = $record['imagetitletext'];
      $imageConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];

      $thumbnailConf['file'] = $uploadDir . $imageRecord['0'];
      $thumbnailConf['file.']['width'] = intval($this->thumbnailWidth).'c';
      $thumbnailConf['file.']['height'] = intval($this->thumbnailHeight);
 
      $marksItem['###KEY###']  = $key + '1';
      $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
      $marksItem['###TITLELINK###']  = $this->cObj->typolink($record['title'], $linkConf);
      if ($record['author']) {
        $marksItem['###AUTHORLINK###']  = $this->cObj->typolink($record['author'], $linkConf) .' -';
      } else {
        $marksItem['###AUTHORLINK###']  = '';
      }
      $marksItem['###DATE###'] = strftime($this->conf['dateFormat'],$record['datetime']);
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      $marksItem['###TITLE###'] = $record['title'];

      if(!$this->conf['fixedLgd']) $this->conf['fixedLgd'] = '120';
      if ($record['short']) {
        $record['short'] = t3lib_div::fixed_lgd_cs($record['short'], $this->conf['fixedLgd']);
        $marksItem['###TEXT###'] = $record['short'];
      } else {
        $record['bodytext'] = t3lib_div::fixed_lgd_cs($record['bodytext'], $this->conf['fixedLgd']);
        $marksItem['###TEXT###'] = $record['bodytext'];
      }
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbnailConf);   		

			$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
			$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
		  $templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
		  $subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
    }

    $content .= $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


 	protected function getContent($sliderRecords) {
    if (!$this->conf['templateFile']) {
      $this->conf['templateFile'] = $this->extPath.'slidercontent_template.html';
    }
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');
    $uploadDir = 'uploads/pics/';
    if ($this->conf['sliderWidth']) {
      $this->sliderWidth = $this->conf['sliderWidth'];
      $this->sliderHeight = '300';
    } else {
      $firstImageResord = reset($sliderRecords);
      $firstImage = t3lib_div::trimExplode(',', $firstImageResord['image']);
      $imageSize    = getimagesize(PATH_site . $uploadDir . $firstImage['0']);
      $this->sliderWidth = $imageSize['0'];
      $this->sliderHeight  =  '300';
    }
    if ($this->conf['sliderHeight']) {
      if ($this->conf['sliderStyle'] == '1' || $this->conf['sliderStyle'] == '4' || $this->conf['sliderStyle'] == '6') { 
        $this->sliderHeight = $this->conf['sliderHeight'];
      }
    }
                     
    $this->imageWidth = $this->sliderWidth;
    $this->imageHeight = $this->sliderHeight;

    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '5') {
      $this->imageWidth = $this->sliderWidth - '295';
    } 
    if ($this->conf['sliderStyle'] == '3') {
      $this->imageWidth = $this->sliderWidth - '293';
    }

    $marks['###SLIDERWIDTH###'] = $this->sliderWidth;
    $marks['###IMAGEWIDTH###'] = $this->imageWidth;
    $marks['###IMAGEHEIGHT###'] = $this->imageHeight;
    
    $thumbnailWidth  = $this->imageWidth / '12';
    $this->thumbnailWidth  = t3lib_div::intval_positive($thumbnailWidth);
    $thumbnailHeight  = $this->imageHeight / '12';
    $this->thumbnailHeight  = t3lib_div::intval_positive($thumbnailHeight);
    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '3' || $this->conf['sliderStyle'] == '5') {
      $this->thumbnailWidth  = '60';
      $this->thumbnailHeight  = '60';
    }

 		foreach ($sliderRecords as $key => $record) {
      $linkConf = array(
        'parameter'         => $record['pid'],
        'ATagParams'        => 'class="readmore"',
        'target'            => '_parent'
      );
      $imageRecord = t3lib_div::trimExplode(',', $record['image']);

      $imageConf['file'] = $uploadDir . $imageRecord['0'];
      $imageConf['file.']['width'] = intval($this->imageWidth).'c';
      $imageConf['file.']['height'] = intval($this->imageHeight);
      $imageConf['stdWrap.']['addParams.']['title'] = $record['titleText'];
      $imageConf['stdWrap.']['addParams.']['alt'] = $record['altText'];

      $thumbnailConf['file'] = $uploadDir . $imageRecord['0'];
      $thumbnailConf['file.']['width'] = intval($this->thumbnailWidth).'c';
      $thumbnailConf['file.']['height'] = intval($this->thumbnailHeight);
 
      $marksItem['###KEY###']  = $key + '1';
      $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
      $marksItem['###TITLELINK###']  = $this->cObj->typolink($record['header'], $linkConf);
      if ($record['date']) {
        $marksItem['###DATE###'] = strftime($this->conf['dateFormat'],$record['date']);
      } else {
        $marksItem['###DATE###'] = '';
      }
      $marksItem['###SUBTITLE###'] = $record['subheader'];
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      $marksItem['###TITLE###'] = $record['header'];

      if(!$this->conf['fixedLgd']) $this->conf['fixedLgd'] = '120';
      $record['bodytext'] = t3lib_div::fixed_lgd_cs($record['bodytext'], $this->conf['fixedLgd']);
      $marksItem['###TEXT###'] = $record['bodytext'];

      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbnailConf);   		
			$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
			$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
		  $templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
		  $subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
    }

    $content .= $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


  protected function addHeaderParts() {
    $extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['t3s_jslidernews']);
    $pagerender = $GLOBALS['TSFE']->getPageRenderer();
    // checks if t3jquery is loaded
    if (t3lib_extMgm::isLoaded('t3jquery')) {
      require_once(t3lib_extMgm::extPath('t3jquery').'class.tx_t3jquery.php');
    }
    // if t3jquery is loaded and the custom Library had been created
    if (T3JQUERY === true) {
      tx_t3jquery::addJqJS();
    }
    if ($extConf['includeJquery']) {
      $pagerender->addJsLibrary(' jQuery JavaScript Library ','https://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js', 'text/javascript', TRUE, FALSE, '');
    }
    if($extConf['includeJqueryEasing']) {
      $pagerender->addJsFile($this->extPath.'res/js/jquery.easing.js', 'text/javascript', TRUE, FALSE, '');
    }
    $pagerender->addJsFile($this->extPath.'res/js/jslidernews.js', 'text/javascript', TRUE, FALSE, '');

    if (!$this->conf['duration']) $this->conf['duration'] = '1200'; 
    if ($this->conf['auto']) $this->conf['auto'] = 'true'; 
    else $this->conf['auto'] = 'false';
    if (!$this->conf['interval']) $this->conf['interval'] = '4000'; 

    switch ($this->conf['sliderStyle']) {
      case '1':
        $navigatorHeight = $this->thumbnailHeight + '10';
        $navigatorWidth = $this->thumbnailWidth + '10';
        $js = '$(document).ready( function(){	
          var buttons = { previous:$(\'#lofslidecontent45 .lof-previous\') ,
  	      next:$(\'#lofslidecontent45 .lof-next\') };
          $obj = $(\'#lofslidecontent45\').lofJSidernews( { 
            interval        : '.$this->conf['interval'].',	
            easing			    : \''.$this->conf['easing'].'\', 
            duration		    : '.$this->conf['duration'].',
            auto		 	      : '.$this->conf['auto'].',
            maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
            navPosition     : \'horizontal\',
            navigatorHeight : '.$navigatorHeight.',
            navigatorWidth  : '.$navigatorWidth.',
            mainWidth       : '.$this->sliderWidth.',
            buttons			    : buttons} );	
          });';
        $file = $this->extPath.'res/css/style1.css';
      break;
      case '2':
        $js = '$(document).ready( function(){	
          $(\'#lofslidecontent45\').lofJSidernews( { 
            interval        : '.$this->conf['interval'].',
  					easing          : \''.$this->conf['easing'].'\', 
  					duration        : '.$this->conf['duration'].',
  					mainWidth       :  '.$this->imageWidth.',
  					auto            : '.$this->conf['auto'].' } );					
    	    });';
        $file = $this->extPath.'res/css/style2.css';
        $block = 'ul.lof-main-wapper {width:'.$this->imageWidth.'px;}'; 
      break;
      case '3':
        $js = '$(document).ready( function(){	
          $(\'#lofslidecontent45\').lofJSidernews( { 
            interval        : '.$this->conf['interval'].',
  					easing          : \''.$this->conf['easing'].'\', 
  					mainWidth       :  '.$this->imageWidth.',
  					duration        : '.$this->conf['duration'].',
  					auto            : '.$this->conf['auto'].' } );						
  	     });';
        $file = $this->extPath.'res/css/style3.css';
      break;
      case '4':
        $js = '$(document).ready( function(){	
      		$obj = $(\'#lofslidecontent45\').lofJSidernews( { 
            interval        : '.$this->conf['interval'].',
			   	 	easing			    : \''.$this->conf['easing'].'\', 
						duration		    : '.$this->conf['duration'].',
				  	auto		 	      : '.$this->conf['auto'].',
						maxItemDisplay  :'.$this->conf['maxItemDisplay'].',
						navPosition     : \'horizontal\',
						navigatorHeight : 15,
						navigatorWidth  : 25,
						mainWidth       : '.$this->sliderWidth.'} );	
	        });';
        $file = $this->extPath.'res/css/style4.css';
      break;
      case '5':
        $js = '$(document).ready( function(){	
		      $(\'#lofslidecontent45\').lofJSidernews( {
            interval        : '.$this->conf['interval'].',
  	        auto            : '.$this->conf['auto'].',
						direction       : \'opacity\',
  					mainWidth       :  '.$this->imageWidth.',
						duration        : '.$this->conf['duration'].',
						easing          : \''.$this->conf['easing'].'\'} );						
        	});';
        $file = $this->extPath.'res/css/style5.css';
      break;
      case '6':
        $js = ' $(document).ready( function(){	
		      var buttons = { previous:$(\'#lofslidecontent45 .lof-previous\') ,
					next:$(\'#lofslidecontent45 .lof-next\') };
					$obj = $(\'#lofslidecontent45\').lofJSidernews( { 
            interval        : '.$this->conf['interval'].',
						direction		    : \'opacity\',	
						easing			    : \''.$this->conf['easing'].'\', 
						duration		    : '.$this->conf['duration'].',
						auto		 	      : '.$this->conf['auto'].',
  					mainWidth       :  '.$this->sliderWidth.',
						buttons			    : buttons} );	
	       });';
        $file = $this->extPath.'res/css/style6.css';
      break;
    }
 
    $pagerender->addCssInlineBlock('inlineStyle', $block, $compress = FALSE, $forceOnTop = FALSE); 	
    $pagerender->addCssFile($file, $rel = 'stylesheet', $media = 'all', $title = 'style1',	$compress = TRUE,	$forceOnTop = FALSE, $allWrap = ''); 
    $name=' JavaScript for EXT '.$this->extKey.' ';
    $pagerender->addJsFooterInlineCode($name,$js);  
  }

	
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php']);
}

?>